import requests
import pandas as pd
import csv
import sys


client_id = 'be8f9126-110d-447a-8000-8c64382a1957'
station = input('Enter station: ')
start_date = input('Enter start date: ')
end_date = input('Enter end date: ')
filenumber = input('Enter filenumber: ')

endpoint = 'https://frost.met.no/observations/v0.jsonld'
parameters = {
    'sources': station,
    'elements': 'min(air_temperature PT1H),surface_snow_thickness',
    'referencetime': start_date + '/' + end_date + 'T23:01'
}

r = requests.get(endpoint, parameters, auth=(client_id, ''))
json = r.json()

if r.status_code != 200:
    print('Error! Returned status code %s' % r.status_code)
    print('Message: %s' % json['error']['message'])
    print('Reason: %s' % json['error']['reason'])
    sys.exit(1)

data = json['data']
print('Data retrieved from frost.met.no!')


with open('testtemp.csv', 'w') as new_file:
    for line in data:
        for i in line["observations"]:

            try:
                if str(i["level"]["value"]) != '10':
                    new_file.write(line["referenceTime"] +','+ 
                    i["elementId"] +','+ 
                    str(i["value"]) +','+ 
                    i["timeOffset"] +','+ 
                    str(i["level"]["value"]) + "\n")
            except KeyError:
                #if i["timeOffset"] != "PT6H":
                    new_file.write(line["referenceTime"]+','+
                i["elementId"] +','+ 
                str(i["value"]) +','+ 
                i["timeOffset"] + "\n")
                
new_file.close()
last_row = ["time", "element"]
with open('testtemp.csv', 'r') as read_file:
    csv_reader = csv.reader(read_file, delimiter=',')
    with open(station + '.' + filenumber +'.csv', 'w') as write_file:
        for row in csv_reader:
            if str(row[0]) == str(last_row[0]):
                if str(row[1]) != str(last_row[1]):
                    write_file.write(row[0] + ',' + 
                    last_row[2] + ',' + 
                    row[2] + '\n')
                    last_row = row
            else:
                last_row = row

read_file.close()
write_file.close()

sys.exit(0)

# This will return a Dataframe with all of the observations in a table format
df = pd.DataFrame()
for i in range(len(data)):
    df.append(data[i])
    row = pd.DataFrame(data[i]['observations'])
    row['referenceTime'] = data[i]['referenceTime']
    row['sourceId'] = data[i]['sourceId']
    df = df.append(row)

df = df.reset_index()


# These additional columns will be kept
columns = ['referenceTime', 'elementId', 'value', 'unit', 'timeOffset']
df2 = df[columns].copy()
# Convert the time value to something Python understands
df2['referenceTime'] = pd.to_datetime(df2['referenceTime'])
# df2.head()


with open('testtemp.csv', 'w') as new_file:
    csv_writer = csv.writer(new_file)
    df2.to_csv(new_file)
new_file.close()
